module CrmBmsCms
  module ClientEnum
    extend ActiveSupport::Concern
    included do
      enum account_type: %i[
        normal_account
        simulate_account
        test_account
        gift_account
        trial_account
        normal_trial_account
      ]

      enum staff_size: %i[less_10 bewteen_10_20 bewteen_20_50 bewteen_50_100 bewteen_100_500 greate_500]
  
      enum source: {
        normal_source: 0,
        agent_source: 1,
        vcooline_agent_source: 2,
        ikcms: 3,
        api_ios: 4,
        api_android: 5,
        yunmart: 6,
        dingding_source: 7,
        kingdee_source: 8,
        dingding_invitation: 9,
        unicom: 10,
        market_aliyun: 11,
        dingding_star_activity: 12,
        dingding_experience: 13,
        wx_website: 14,
        wx_agent_source: 15,
        wx_customization: 17,
        wx_agent_customization: 18
      }

      enum industry: %i[telecom education high_tech government manufacturing
        services energy retail media entertainment
        consulting finance utilities non_profit_business other]

      enum business_type: %i[to_b to_c]

      enum soukebao_status: %i[soukebao_disabled soukebao_enabled]

      # CMS针对 Client#product_type 的配置
      # enum_attr :product_type, :in => [
      #   ['normal_aike_crm', 0, "爱客CRM"],
      #   ['dingding_aike_crm', 1, '爱客钉钉CRM'],
      #   ['kingdee_aike_crm', 2, '爱客云之家CRM'],
      #   ['aliyun_dingding_aike_crm', 3, '阿里云套件爱客'],
      #   ['aliyun_market_dingding_aike_crm', 4, '阿里云办公爱客'],
      #   ['dingding_invoicing', 5, '进销存钉钉版'],
      #   ['aliyun_market_independent_crm', 6, '阿里云独立版爱客'],
      #   ['aliyun_mail_aike_crm', 7, '阿里云邮箱爱客'],
      #   ['wx_crm', 8, '励销CRM'],
      #   ['wx_invoicing', 9, '励销进销存'],
      #   ['aliyun_market_invoicing', 10, '阿里云办公进销存']
      # ]
      enum product_type: {
        normal_aike_crm: 0,
        dingding_aike_crm: 1,
        kingdee_aike_crm: 2,
        aliyun_dingding_oa_aike_crm: 3,
        aliyun_dingding_one_aike_crm: 4,
        wx_aike_crm: 8
      }

      enum buy_sms_status: {
        buy_sms_disabled: 0,
        buy_sms_enabled: 1
      }

      enum dingding_permission_type: %i[account_free account_payment]
      enum dingding_status: %i[dingding_status_normal dingding_status_close]
      enum dingding_crm_plan_status: {
        dingding_crm_plan_pending: 0,
        dingding_crm_plan_verifying: 1,
        dingding_crm_plan_bought: 2,
        dingding_crm_plan_bought_fail: 3,
        dingding_crm_plan_refunded: 4
      }

      enum kingdee_permission_type: %i[kingdee_account_free kingdee_account_payment]
      enum kingdee_status: %i[kingdee_status_normal kingdee_status_close]
      enum kingdee_account_type: %i[kingdee_normal_account kingdee_trial_account kingdee_test_account]

      enum dingding_follow_status: %i[dingding_follow_pending
                            dingding_follow_want_buy
                            dingding_follow_not_want_buy
                            dingding_follow_uncertain]

      enum dingding_account_type: {
        dingding_trial_account: 0,
        dingding_normal_account: 1,
        dingding_test_account: 2
      }

      enum dingding_category: {
        dingding_category_pending: 0,
        dingding_category_pending_with_contact: 5,
        dingding_category_has_contact: 1,
        dingding_category_pending_training: 2,
        dingding_category_train_booked: 3,
        dingding_category_contacted_no_train: 6,
        dingding_category_trained: 4
      }

      enum dingding_source: %i[dingding_source_hq dingding_source_develop]

      enum dingding_trial_apply_status: %i[dingding_trial_apply_pending
                                dingding_trial_applied]

      # wx_trial_account 未付费，wx_normal_account 已付费
      enum wx_account_type: {
        wx_trial_account: 0,
        wx_normal_account: 1,
        wx_test_account: 2
      }

      enum wx_crm_plan_status: {
        wx_crm_plan_pending: 0,
        wx_crm_plan_verifying: 1,
        wx_crm_plan_bought: 2,
        wx_crm_plan_bought_fail: 3,
        wx_crm_plan_refunded: 4
      }

      enum wx_status: {
        wx_status_normal: 0,
        wx_status_close: 1
      }

      # wx_free_permission 免费权限，wx_paid_permission vip付费权限
      enum wx_permission_type: {
        wx_free_permission: 0,
        wx_paid_permission: 1
      }

      enum wx_category: {
        wx_category_pending: 0,
        wx_category_has_contact: 1,
        wx_category_pending_training: 2,
        wx_category_train_booked: 3,
        wx_category_trained: 4,
        wx_category_pending_with_contact: 5,
        wx_category_contacted_no_train: 6
      }

      enum wx_follow_status: {
        wx_follow_pending: 0,
        wx_follow_want_buy: 1,
        wx_follow_not_want_buy: 2,
        wx_follow_uncertain: 3
      }

      enum wx_trial_apply_status: {
        wx_trial_apply_pending: 0,
        wx_trial_applied: 1
      }

      enum achievement: %i[achievement_disabled achievement_enabled]
    end
  end
end
